#ifndef __HtmlParser_H__
#define __HtmlParser_H__

#include <stdlib.h>
#include <stdio.h>
#include <stddef.h>

// HtmlParser࣬ڽHTMLı
// http://blog.csdn.net/liigo/article/details/6153829 (Ҫ)
// by liigo, @2010-2012

namespace liigo
{

	//MemBuffer: ڴ滺࣬洢
#define MEM_DEFAULT_BUFFER_SIZE  256
	class MemBuffer
	{
	public:
		//nBufferSizeָʼС(ֽ), Ϊ-1ʾʹĬϳʼС(MEM_DEFAULT_BUFFER_SIZE)
		//nBufferSizeΪ0ʱݲ仺ڴ棬ӳٵһдʱٷ
		MemBuffer(size_t nBufferSize = -1);
		MemBuffer(const MemBuffer& other); //otherݣз
		virtual ~MemBuffer(); //ʱͷڴ棬Ѿdetach()
		const MemBuffer& operator= (const MemBuffer& other); //ݺٰotherڵݸƽ

	public:
		//򻺴ݿ飬дݵĩβҪʱԶ仺
		//дݿ׵ַڻеƫ
		size_t appendData(const void* pData, size_t nSize);
		//ָoffsetָnSizeݣpDataΪNULLʱݾΪ0ֵֽԭԶƣҪʱԶ仺
		void insertData(size_t offset, const void* pData, size_t nSize);
		//ָoffsetɾָsizeݣԭԶǰ
		void deleteData(size_t offset, size_t size);
		//ȡ׵ַ(ݳΪ0ʱNULL)
		//appendXXX()insertData()resetSize()shrink()exchange()operator=ܻ֮ᵼ׵ַı
		inline void* getData() const { return (m_nDataSize == 0 ? NULL : m_pBuffer); }
		//ȡָƫƴݵַƫoffsetӦСgetDataSize()򲻱֤صĵַЧ
		inline void* getOffsetData(int offset) const { return (m_nDataSize == 0 ? NULL : ((unsigned char*)m_pBuffer + offset)); }
		//ȡݳ
		inline size_t getDataSize() const { return m_nDataSize; }
		//ݳȣ³ȿΪֵҪʱԶ仺ӵݾΪ0ֵֽ
		void resetDataSize(size_t size = 0);
		//ݣЧresetDataSize(0)
		inline void empty() { resetDataSize(0); }
		//ⳤʱռòʹõڴ棬еȻ
		void shrink();
		//ͷڴ
		void clean();
		//еݣûӦиfree()ͷdetach():
		//׵ַݳΪdetach()ǰgetDataSize()صĳ
		//detach()ʱָbShrinkΪtrueЧ˷δʹõĻڴ
		void* detach(bool bShrink = true);
		//(this & other)Թݣݺͻ
		void exchange(MemBuffer& other);

		//ӻ
		inline size_t appendInt(int i) { return appendData(&i, sizeof(i)); }
		inline size_t appendChar(char c) { return appendData(&c, sizeof(c)); }
		//ָpֵpָݣӵ
		inline size_t appendPointer(const void* p) { return appendData(&p, sizeof(p)); }
		//ıӵ, lenΪдֽ-1ʾstrlen(szText)appendZeroCharʾǷ'\0'
		size_t appendText(const char* szText, size_t len = -1, bool appendZeroChar = false);
		//ָ0ֵֽӵ
		size_t appendZeroBytes(int count);

		//ȡļȫݣkeepExistData=trueԭݣԭ
		//appendZeroCharʾǷַ'\0'pReadBytesrNULLдļжȡֽ
		//ڴ̶дδȡļݵ£falseѾȡĲȻpReadBytesrлдȡֽ
		bool loadFromFile(const char* szFileName, bool keepExistData = false, bool appendZeroChar = false, size_t* pReadBytes = NULL);
		//ݱ浽ļ(pBOM,bomLen)ΪдļͷBOM(Byte Order Mark)
		//ļѾڣֱӸǵԭļ
		bool saveToFile(const char* szFileName, const void* pBOM = NULL, size_t bomLen = 0);

	private:
		//Ҫ󻺴Ϊsizeδʹÿռ
		//δʹÿռ׵ַݵĩβ
		void* require(size_t size);

	private:
		unsigned char* m_pBuffer; //׵ַ
		size_t m_nDataSize, m_nBufferSize; //ݳȣ
	};

	enum HtmlNodeType
	{
		NODE_NULL = 0,  //Ϊнڵս
		NODE_START_TAG, //ʼǩ <a href="liigo.com">  <br/>
		NODE_END_TAG,   //ǩ </a>
		NODE_CONTENT,   //: ڿʼǩ/ǩ֮ͨı
		NODE_REMARKS,   //ע: <!-- -->
		NODE_UNKNOWN,   //δ֪Ľڵ
		_NODE_USER_ = 10, //ûڵֵӦ_NODE_USER_ȷ涨ĳֵظ
	};

	enum HtmlTagType
	{
		TAG_UNKNOWN = 0, //ʾδʶıǩͣμHtmlParser.onIdentifyHtmlTag()
		TAG_SCRIPT, TAG_STYLE, TAG_TEXTAREA, //ڽҪʶ<script>,<style><textarea>ڲر
		//°ǩĸ˳, Դhttp://www.w3.org/TR/html4/index/elements.html (HTML4)
		//and http://www.w3.org/TR/html5/section-index.html#elements-1 (HTML5)
		//˴ֵһʶǣμHtmlParser.onIdentifyHtmlTag()
		TAG_A = 11, TAG_ABBR, TAG_ACRONYM, TAG_ADDRESS, TAG_APPLET, TAG_AREA, TAG_ARTICLE, TAG_ASIDE, TAG_AUDIO, 
		TAG_B, TAG_BASE, TAG_BASEFONT, TAG_BDI, TAG_BDO, TAG_BIG, TAG_BLOCKQUOTE, TAG_BODY, TAG_BR, TAG_BUTTON, 
		TAG_CAPTION, TAG_CENTER, TAG_CITE, TAG_CODE, TAG_COL, TAG_COLGROUP, TAG_COMMAND, 
		TAG_DATALIST, TAG_DD, TAG_DEL, TAG_DETAILS, TAG_DFN, TAG_DIR, TAG_DIV, TAG_DL, TAG_DT, TAG_EM, TAG_EMBED, 
		TAG_FIELDSET, TAG_FIGCAPTION, TAG_FIGURE, TAG_FONT, TAG_FOOTER, TAG_FORM, TAG_FRAME, TAG_FRAMESET, 
		TAG_H1, TAG_H2, TAG_H3, TAG_H4, TAG_H5, TAG_H6, TAG_HEAD, TAG_HEADER, TAG_HGROUP, TAG_HR, TAG_HTML, 
		TAG_I, TAG_IFRAME, TAG_IMG, TAG_INPUT, TAG_INS, TAG_ISINDEX, TAG_KBD, TAG_KEYGEN, 
		TAG_LABEL, TAG_LEGEND, TAG_LI, TAG_LINK, TAG_MAP, TAG_MARK, TAG_MENU, TAG_META, TAG_METER, TAG_NAV, TAG_NOFRAMES, TAG_NOSCRIPT, 
		TAG_OBJECT, TAG_OL, TAG_OPTGROUP, TAG_OPTION, TAG_P, TAG_PARAM, TAG_PRE, TAG_PROGRESS, TAG_Q, TAG_RP, TAG_RT, TAG_RUBY, 
		TAG_S, TAG_SAMP, TAG_SECTION, TAG_SELECT, TAG_SMALL, TAG_SOURCE, TAG_SPAN, TAG_STRIKE, TAG_STRONG, TAG_SUB, TAG_SUMMARY, TAG_SUP, 
		TAG_TABLE, TAG_TBODY, TAG_TD, TAG_TFOOT, TAG_TH, TAG_THEAD, TAG_TIME, TAG_TITLE, TAG_TR, TAG_TRACK, TAG_TT, 
		TAG_U, TAG_UL, TAG_VAR, TAG_VIDEO, TAG_WBR, 
		_TAG_USER_TAG_ = 150, //ûǩֵӦ_TAG_USER_TAG_ȷ涨ĳֵظ
	};

	enum HtmlNodeFlag
	{
		//flags used in HtmlNode.flags
		FLAG_SELF_CLOSING_TAG = 1 << 0, //Էձǩ: <br/>
		FLAG_CDATA_BLOCK      = 1 << 1, //CDATA
		FLAG_NEED_FREE_TEXT   = 1 << 2, //free(HtmlNode.text)

		//flags used in HtmlAttribute.flags
		FLAG_NEED_FREE_NAME   = 1 << 0, //free(HtmlAttribute.name)
		FLAG_NEED_FREE_VALUE  = 1 << 1, //free(HtmlAttribute.value)
	};

	struct HtmlAttribute
	{
		char* name;   //
		char* value;  //ֵ
		size_t flags; //bit OR of HtmlNodeFlag
	};

#define MAX_HTML_TAG_LENGTH  15 //ڵƵַ,ض

	struct HtmlNode
	{
		HtmlNodeType type;    //ڵ
		HtmlTagType  tagType; //ǩͣڵΪNODE_START_TAGNODE_END_TAGʱ壩
		char tagName[MAX_HTML_TAG_LENGTH+1]; //ǩƣ<A href="...">ӦıǩΪ"A"
		char* text; //ıӱǩ(tagType)ͬҲͬΪNULL
		//type==NODE_START_TAG, textָǩƺı
		//type==NODE_CONTENTNODE_REMARKS, textָݻעı
		int attributeCount;    //ԸԱЧμHtmlParser.parseAttributes()ͬ
		MemBuffer* attributes; //ԣ=ֵμHtmlParser.getAttribute()Զ̬ԡ
		size_t flags;    //bit OR of HtmlNodeFlag
		void* pUser;     //user customized, default to NULL
	};


	//HtmlParser: HTMLı
	class HtmlParser
	{
	public:
		HtmlParser() {}
		virtual ~HtmlParser() { cleanHtmlNodes(); }

	private:
		//disallow copy and assign: only declare, no implementation
		HtmlParser(const HtmlParser&);
		void operator=(const HtmlParser&);

	public:
		//HTMLһϵ洢HtmlNodeڵ㣨ͨgetHtmlNode(index)ȡ
		//ȻһNODE_NULLڵ(HtmlNode.type==NODE_NULL)Ϊнڵս
		//parseAttributesΪtrueʱ麯onParseAttributes()ҪʱãûлǷ
		//parseAttributesΪfalseʾκԣonParseAttributes()Ҳ
		void parseHtml(const char* szHtml, bool parseAttributes = true);

		//ȡڵһӵNODE_NULLڵ㣩
		int getHtmlNodeCount();
		//ȡָĽڵ㣬Ϸ: 0 <= index <= getHtmlNodeCount()
		//һڵ㣨index==getHtmlNodeCount()ΪӵNODE_NULLڵ
		HtmlNode* getHtmlNode(int index);

		static bool cloneHtmlNode(const HtmlNode* pSrcNode, HtmlNode* pDestNode); //ʹcleanHtmlNode()
		static void cleanHtmlNode(HtmlNode* pNode); //ֻڵж̬ݣtype,tagType,tagName,flags,pUser
		void cleanHtmlNodes(); //нڵ㲢ͷռڴ

		//attributes
		static const HtmlAttribute* getAttribute(const HtmlNode* pNode, size_t index); //must: 0 <= index < pNode->attributeCount
		static const HtmlAttribute* getAttribute(const HtmlNode* pNode, const char* szAttributeName); //return NULL if attribute not exist
		static const char* getAttributeStringValue(const HtmlNode* pNode, const char* szAttributeName, const char* szDefaultValue = NULL);
		static int getAttributeIntValue(const HtmlNode* pNode, const char* szAttributeName, int defaultValue = 0);
		static void parseAttributes(HtmlNode* pNode); //pNode->text, ͨonParseAttributes()ʹ
		static void parseExtraAttributes(const char* szAttributesText, HtmlNode* pTargetNode, const char* szNamePrefix = NULL); //ıszAttributesTextԲpTargetNodeԭԣ, szNamePrefixָӵǰ׺Է½ԭƳͻ
		//output
		void outputHtml(MemBuffer& buffer, bool keepBufferData = false);
		static void outputHtmlNode(MemBuffer& buffer, const HtmlNode* pNode);
		void dumpHtmlNodes(FILE* f = stdout); //for debug or test
		static void dumpHtmlNode(const HtmlNode* pNode, int nodeIndex = -1, FILE* f = stdout);

	protected:
		//า, Աʶǩ(߽), ʶٱǩ(߽ٶ)
		//ĬϽʶ漰HTMLṹϢ޼ʼǩ: A,IMG,META,BODY,TITLE,FRAME,IFRAME
		//onIdentifyHtmlTag()onParseAttributes()
		virtual HtmlTagType onIdentifyHtmlTag(const char* szTagName, HtmlNodeType nodeType);
		//า, ԱõĽڵ, ֽ߲ɴ಻ڵ(߽ٶ)
		//Ըݱǩ(pNode->tagName)ǩ(pNode->tagType)жǷҪԣparseAttributes()
		//ĬϽ"ʶǩ"ıǩԣpNode->tagType != TAG_UNKNOWN
		virtual void onParseAttributes(HtmlNode* pNode);
		//า, ĳڵɺ󱻵, falseֹͣHTML
		//ҲһǡʱʼpNode->pUser
		virtual bool onNodeReady(HtmlNode* pNode) { return true; }

	private:
		HtmlNode* appendHtmlNode();

	private:
		MemBuffer m_HtmlNodes;
	};

} //namespace liigo

#endif //__HtmlParser_H__